import Vue, { VueConstructor } from 'vue';
import { Store } from 'vuex';
import Router from 'vue-router';
import { IComponentInitParam } from './component';
import { IDirectiveInitParam } from './directive';
import { IFilterInitParam } from './filter';
import { IMixinInitParam } from './mixin';
import { IPluginInitParam } from './plugins';
import { IPrototypeInitParam } from './prototype';
import { IRouterInitParam } from './router';
import { IStoreInitParam } from './store';
import { IServiceWorkerInitParam } from './serviceWorker';
export declare namespace Maintainer {
    interface IResult<S> {
        buildEnv: string;
        router: Router | null;
        store: Store<S> | null;
    }
    interface IOption<V extends Vue, T, S, P> {
        showLogEnvs: string[];
        router?: IRouterInitParam<V>;
        store?: IStoreInitParam<T, S>;
        plugins?: IPluginInitParam<P> | null;
        serviceWorker?: IServiceWorkerInitParam | null;
        prototype?: IPrototypeInitParam | null;
        filter?: IFilterInitParam | null;
        component?: IComponentInitParam | null;
        mixin?: IMixinInitParam | null;
        directive?: IDirectiveInitParam | null;
    }
    function initialize<V extends Vue, T, S, P>(vue: VueConstructor<V>, maintainerOption: IOption<V, T, S, P>): IResult<S>;
    function getBuildEnv(): string;
}
